/*
 * Copyright (c) 2018, 2020, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */


/*
 * @test
 *
 * @summary converted from VM Testbase nsk/jdi/EventSet/virtualMachine/virtualmachine001.
 * VM Testbase keywords: [quick, jpda, jdi]
 * VM Testbase readme:
 * DESCRIPTION:
 *  The test for public virtualMachine() method of an implementing class of
 *  com.sun.jdi.EventSet interface. This method is inherited from
 *  com.sun.jdi.Mirror interface.
 *  The test checks an assertion :
 *     public VirtualMachine virtualMachine()
 *     Gets the VirtualMachine to which this Mirror belongs.
 *     A Mirror must be associated with a VirtualMachine to have any meaning.
 *       Returns:
 *             the VirtualMachine for which this mirror is a proxy.
 * COMMENTS:
 *  The test is aimed to increase jdi source code coverage and checks
 *  the code which was not yet covered by previous tests for EventSet
 *  interface. The coverage analysis was done for jdk1.4.0-b92 build.
 *     Test was fixed according to test bug:
 *     4778296 TEST_BUG: debuggee VM intemittently hangs after resuming
 *     - handling VMStartEvent was removed from the debugger part of the test
 *     Test fixed according to test bug:
 *     4798088 TEST_BUG: setBreakpoint() method depends of the locations implementation
 *     - using standard Debugee.setBreakpoint() method
 *     - adjusting source line numbers for setting breakpoints
 *
 * @library /vmTestbase
 *          /test/lib
 * @build nsk.jdi.EventSet.virtualMachine.virtualmachine001
 *        nsk.jdi.EventSet.virtualMachine.virtualmachine001a
 * @run main/othervm PropertyResolvingWrapper
 *      nsk.jdi.EventSet.virtualMachine.virtualmachine001
 *      -verbose
 *      -arch=${os.family}-${os.simpleArch}
 *      -waittime=5
 *      -debugee.vmkind=java
 *      -transport.address=dynamic
 *      "-debugee.vmkeys=${test.vm.opts} ${test.java.opts}"
 */

